diff --git a/src/backend/catalog/pg_type.c b/src/backend/catalog/pg_type.c
index fc369c35aa6..0270a2e3d32 100644
--- a/src/backend/catalog/pg_type.c
+++ b/src/backend/catalog/pg_type.c
@@ -60,8 +60,8 @@ TypeShellMake(const char *typeName, Oid typeNamespace, Oid ownerId)
 	TupleDesc	tupDesc;
 	int			i;
 	HeapTuple	tup;
-	Datum		values[Natts_pg_type];
-	bool		nulls[Natts_pg_type];
+	Datum		values[Natts_pg_type] = {0};
+	bool		nulls[Natts_pg_type] = {false};
 	Oid			typoid;
 	NameData	name;
 	ObjectAddress address;
@@ -92,37 +92,37 @@ TypeShellMake(const char *typeName, Oid typeNamespace, Oid ownerId)
 	 * mistaken for a usable type.
 	 */
 	namestrcpy(&name, typeName);
-	values[Anum_pg_type_typname - 1] = NameGetDatum(&name);
-	values[Anum_pg_type_typnamespace - 1] = ObjectIdGetDatum(typeNamespace);
-	values[Anum_pg_type_typowner - 1] = ObjectIdGetDatum(ownerId);
-	values[Anum_pg_type_typlen - 1] = Int16GetDatum(sizeof(int32));
-	values[Anum_pg_type_typbyval - 1] = BoolGetDatum(true);
-	values[Anum_pg_type_typtype - 1] = CharGetDatum(TYPTYPE_PSEUDO);
-	values[Anum_pg_type_typcategory - 1] = CharGetDatum(TYPCATEGORY_PSEUDOTYPE);
-	values[Anum_pg_type_typispreferred - 1] = BoolGetDatum(false);
-	values[Anum_pg_type_typisdefined - 1] = BoolGetDatum(false);
-	values[Anum_pg_type_typdelim - 1] = CharGetDatum(DEFAULT_TYPDELIM);
-	values[Anum_pg_type_typrelid - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typsubscript - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typelem - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typarray - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typinput - 1] = ObjectIdGetDatum(F_SHELL_IN);
-	values[Anum_pg_type_typoutput - 1] = ObjectIdGetDatum(F_SHELL_OUT);
-	values[Anum_pg_type_typreceive - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typsend - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typmodin - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typmodout - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typanalyze - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typalign - 1] = CharGetDatum(TYPALIGN_INT);
-	values[Anum_pg_type_typstorage - 1] = CharGetDatum(TYPSTORAGE_PLAIN);
-	values[Anum_pg_type_typnotnull - 1] = BoolGetDatum(false);
-	values[Anum_pg_type_typbasetype - 1] = ObjectIdGetDatum(InvalidOid);
-	values[Anum_pg_type_typtypmod - 1] = Int32GetDatum(-1);
-	values[Anum_pg_type_typndims - 1] = Int32GetDatum(0);
-	values[Anum_pg_type_typcollation - 1] = ObjectIdGetDatum(InvalidOid);
-	nulls[Anum_pg_type_typdefaultbin - 1] = true;
-	nulls[Anum_pg_type_typdefault - 1] = true;
-	nulls[Anum_pg_type_typacl - 1] = true;
+	HeapTupleSetValue(pg_type, typname, NameGetDatum(&name), values);
+	HeapTupleSetValue(pg_type, typnamespace, ObjectIdGetDatum(typeNamespace), values);
+	HeapTupleSetValue(pg_type, typowner, ObjectIdGetDatum(ownerId), values);
+	HeapTupleSetValue(pg_type, typlen, Int16GetDatum(sizeof(int32)), values);
+	HeapTupleSetValue(pg_type, typbyval, BoolGetDatum(true), values);
+	HeapTupleSetValue(pg_type, typtype, CharGetDatum(TYPTYPE_PSEUDO), values);
+	HeapTupleSetValue(pg_type, typcategory, CharGetDatum(TYPCATEGORY_PSEUDOTYPE), values);
+	HeapTupleSetValue(pg_type, typispreferred, BoolGetDatum(false), values);
+	HeapTupleSetValue(pg_type, typisdefined, BoolGetDatum(false), values);
+	HeapTupleSetValue(pg_type, typdelim, CharGetDatum(DEFAULT_TYPDELIM), values);
+	HeapTupleSetValue(pg_type, typrelid, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typsubscript, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typelem, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typarray, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typinput, ObjectIdGetDatum(F_SHELL_IN), values);
+	HeapTupleSetValue(pg_type, typoutput, ObjectIdGetDatum(F_SHELL_OUT), values);
+	HeapTupleSetValue(pg_type, typreceive, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typsend, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typmodin, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typmodout, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typanalyze, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typalign, CharGetDatum(TYPALIGN_INT), values);
+	HeapTupleSetValue(pg_type, typstorage, CharGetDatum(TYPSTORAGE_PLAIN), values);
+	HeapTupleSetValue(pg_type, typnotnull, BoolGetDatum(false), values);
+	HeapTupleSetValue(pg_type, typbasetype, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValue(pg_type, typtypmod, Int32GetDatum(-1), values);
+	HeapTupleSetValue(pg_type, typndims, Int32GetDatum(0), values);
+	HeapTupleSetValue(pg_type, typcollation, ObjectIdGetDatum(InvalidOid), values);
+	HeapTupleSetValueNull(pg_type, typdefaultbin, values, nulls);
+	HeapTupleSetValueNull(pg_type, typdefault, values, nulls);
+	HeapTupleSetValueNull(pg_type, typacl, values, nulls);
 
 	/* Use binary-upgrade override for pg_type.oid? */
 	if (IsBinaryUpgrade)
@@ -141,7 +141,7 @@ TypeShellMake(const char *typeName, Oid typeNamespace, Oid ownerId)
 									Anum_pg_type_oid);
 	}
 
-	values[Anum_pg_type_oid - 1] = ObjectIdGetDatum(typoid);
+	HeapTupleSetValue(pg_type, oid, ObjectIdGetDatum(typoid), values);
 
 	/*
 	 * create a new type tuple
@@ -151,7 +151,7 @@ TypeShellMake(const char *typeName, Oid typeNamespace, Oid ownerId)
 	/*
 	 * insert the tuple in the relation and get the tuple's oid.
 	 */
-	CatalogTupleInsert(pg_type_desc, tup);
+	CatalogTupleInsert(pg_type_desc, tup, NULL);
 
 	/*
 	 * Create dependencies.  We can/must skip this in bootstrap mode.
@@ -229,13 +229,12 @@ TypeCreate(Oid newTypeOid,
 	Oid			typeObjectId;
 	bool		isDependentType;
 	bool		rebuildDeps = false;
-	Acl		   *typacl;
+	Acl		   *typacl = NULL;
 	HeapTuple	tup;
-	bool		nulls[Natts_pg_type];
-	bool		replaces[Natts_pg_type];
-	Datum		values[Natts_pg_type];
+	Datum		values[Natts_pg_type] = {0};
+	bool		nulls[Natts_pg_type] = {false};
+	Bitmapset  *updated = NULL;
 	NameData	name;
-	int			i;
 	ObjectAddress address;
 
 	/*
@@ -334,78 +333,65 @@ TypeCreate(Oid newTypeOid,
 		typeType == TYPTYPE_MULTIRANGE ||
 		(OidIsValid(relationOid) && relationKind != RELKIND_COMPOSITE_TYPE);
 
-	/*
-	 * initialize arrays needed for heap_form_tuple or heap_modify_tuple
-	 */
-	for (i = 0; i < Natts_pg_type; ++i)
-	{
-		nulls[i] = false;
-		replaces[i] = true;
-		values[i] = (Datum) 0;
-	}
+	HeapTupleUpdateSetAllColumnsUpdated(pg_type, updated);
 
-	/*
-	 * insert data values
-	 */
+	/* Insert data values */
 	namestrcpy(&name, typeName);
-	values[Anum_pg_type_typname - 1] = NameGetDatum(&name);
-	values[Anum_pg_type_typnamespace - 1] = ObjectIdGetDatum(typeNamespace);
-	values[Anum_pg_type_typowner - 1] = ObjectIdGetDatum(ownerId);
-	values[Anum_pg_type_typlen - 1] = Int16GetDatum(internalSize);
-	values[Anum_pg_type_typbyval - 1] = BoolGetDatum(passedByValue);
-	values[Anum_pg_type_typtype - 1] = CharGetDatum(typeType);
-	values[Anum_pg_type_typcategory - 1] = CharGetDatum(typeCategory);
-	values[Anum_pg_type_typispreferred - 1] = BoolGetDatum(typePreferred);
-	values[Anum_pg_type_typisdefined - 1] = BoolGetDatum(true);
-	values[Anum_pg_type_typdelim - 1] = CharGetDatum(typDelim);
-	values[Anum_pg_type_typrelid - 1] = ObjectIdGetDatum(relationOid);
-	values[Anum_pg_type_typsubscript - 1] = ObjectIdGetDatum(subscriptProcedure);
-	values[Anum_pg_type_typelem - 1] = ObjectIdGetDatum(elementType);
-	values[Anum_pg_type_typarray - 1] = ObjectIdGetDatum(arrayType);
-	values[Anum_pg_type_typinput - 1] = ObjectIdGetDatum(inputProcedure);
-	values[Anum_pg_type_typoutput - 1] = ObjectIdGetDatum(outputProcedure);
-	values[Anum_pg_type_typreceive - 1] = ObjectIdGetDatum(receiveProcedure);
-	values[Anum_pg_type_typsend - 1] = ObjectIdGetDatum(sendProcedure);
-	values[Anum_pg_type_typmodin - 1] = ObjectIdGetDatum(typmodinProcedure);
-	values[Anum_pg_type_typmodout - 1] = ObjectIdGetDatum(typmodoutProcedure);
-	values[Anum_pg_type_typanalyze - 1] = ObjectIdGetDatum(analyzeProcedure);
-	values[Anum_pg_type_typalign - 1] = CharGetDatum(alignment);
-	values[Anum_pg_type_typstorage - 1] = CharGetDatum(storage);
-	values[Anum_pg_type_typnotnull - 1] = BoolGetDatum(typeNotNull);
-	values[Anum_pg_type_typbasetype - 1] = ObjectIdGetDatum(baseType);
-	values[Anum_pg_type_typtypmod - 1] = Int32GetDatum(typeMod);
-	values[Anum_pg_type_typndims - 1] = Int32GetDatum(typNDims);
-	values[Anum_pg_type_typcollation - 1] = ObjectIdGetDatum(typeCollation);
+	HeapTupleUpdateValue(pg_type, typname, NameGetDatum(&name), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typnamespace, ObjectIdGetDatum(typeNamespace), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typowner, ObjectIdGetDatum(ownerId), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typlen, Int16GetDatum(internalSize), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typbyval, BoolGetDatum(passedByValue), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typtype, CharGetDatum(typeType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typcategory, CharGetDatum(typeCategory), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typispreferred, BoolGetDatum(typePreferred), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typisdefined, BoolGetDatum(true), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typdelim, CharGetDatum(typDelim), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typrelid, ObjectIdGetDatum(relationOid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typsubscript, ObjectIdGetDatum(subscriptProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typelem, ObjectIdGetDatum(elementType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typarray, ObjectIdGetDatum(arrayType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typinput, ObjectIdGetDatum(inputProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typoutput, ObjectIdGetDatum(outputProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typreceive, ObjectIdGetDatum(receiveProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typsend, ObjectIdGetDatum(sendProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typmodin, ObjectIdGetDatum(typmodinProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typmodout, ObjectIdGetDatum(typmodoutProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typanalyze, ObjectIdGetDatum(analyzeProcedure), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typalign, CharGetDatum(alignment), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typstorage, CharGetDatum(storage), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typnotnull, BoolGetDatum(typeNotNull), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typbasetype, ObjectIdGetDatum(baseType), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typtypmod, Int32GetDatum(typeMod), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typndims, Int32GetDatum(typNDims), values, nulls, updated);
+	HeapTupleUpdateValue(pg_type, typcollation, ObjectIdGetDatum(typeCollation), values, nulls, updated);
 
 	/*
-	 * initialize the default binary value for this type.  Check for nulls of
-	 * course.
+	 * Initialize the default binary value for this type.
 	 */
 	if (defaultTypeBin)
-		values[Anum_pg_type_typdefaultbin - 1] = CStringGetTextDatum(defaultTypeBin);
+		HeapTupleUpdateValue(pg_type, typdefaultbin, CStringGetTextDatum(defaultTypeBin), values, nulls, updated);
 	else
-		nulls[Anum_pg_type_typdefaultbin - 1] = true;
+		HeapTupleUpdateValueNull(pg_type, typdefaultbin, values, nulls, updated);
 
 	/*
-	 * initialize the default value for this type.
+	 * Initialize the default value for this type.
 	 */
 	if (defaultTypeValue)
-		values[Anum_pg_type_typdefault - 1] = CStringGetTextDatum(defaultTypeValue);
+		HeapTupleUpdateValue(pg_type, typdefault, CStringGetTextDatum(defaultTypeValue), values, nulls, updated);
 	else
-		nulls[Anum_pg_type_typdefault - 1] = true;
+		HeapTupleUpdateValueNull(pg_type, typdefault, values, nulls, updated);
 
 	/*
-	 * Initialize the type's ACL, too.  But dependent types don't get one.
+	 * Initialize the type's ACL too, but dependent types don't get one.
 	 */
-	if (isDependentType)
-		typacl = NULL;
-	else
-		typacl = get_user_default_acl(OBJECT_TYPE, ownerId,
-									  typeNamespace);
+	if (!isDependentType)
+		typacl = get_user_default_acl(OBJECT_TYPE, ownerId, typeNamespace);
+
 	if (typacl != NULL)
-		values[Anum_pg_type_typacl - 1] = PointerGetDatum(typacl);
+		HeapTupleUpdateValue(pg_type, typacl, PointerGetDatum(typacl), values, nulls, updated);
 	else
-		nulls[Anum_pg_type_typacl - 1] = true;
+		HeapTupleUpdateValueNull(pg_type, typacl, values, nulls, updated);
 
 	/*
 	 * open pg_type and prepare to insert or update a row.
@@ -431,9 +417,7 @@ TypeCreate(Oid newTypeOid,
 					(errcode(ERRCODE_DUPLICATE_OBJECT),
 					 errmsg("type \"%s\" already exists", typeName)));
 
-		/*
-		 * shell type must have been created by same owner
-		 */
+		/* Shell type must have been created by same owner */
 		if (typform->typowner != ownerId)
 			aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_TYPE, typeName);
 
@@ -441,18 +425,16 @@ TypeCreate(Oid newTypeOid,
 		if (OidIsValid(newTypeOid))
 			elog(ERROR, "cannot assign new OID to existing shell type");
 
-		replaces[Anum_pg_type_oid - 1] = false;
+		HeapTupleSetColumnNotUpdated(pg_type, oid, updated);
 
-		/*
-		 * Okay to update existing shell type tuple
-		 */
-		tup = heap_modify_tuple(tup,
+		/* Okay to update existing shell type tuple */
+		tup = heap_update_tuple(tup,
 								RelationGetDescr(pg_type_desc),
 								values,
 								nulls,
-								replaces);
+								updated);
 
-		CatalogTupleUpdate(pg_type_desc, &tup->t_self, tup);
+		CatalogTupleUpdate(pg_type_desc, &tup->t_self, tup, updated, NULL);
 
 		typeObjectId = typform->oid;
 
@@ -480,12 +462,11 @@ TypeCreate(Oid newTypeOid,
 											  Anum_pg_type_oid);
 		}
 
-		values[Anum_pg_type_oid - 1] = ObjectIdGetDatum(typeObjectId);
+		HeapTupleUpdateValue(pg_type, oid, ObjectIdGetDatum(typeObjectId), values, nulls, updated);
 
-		tup = heap_form_tuple(RelationGetDescr(pg_type_desc),
-							  values, nulls);
+		tup = heap_form_tuple(RelationGetDescr(pg_type_desc), values, nulls);
 
-		CatalogTupleInsert(pg_type_desc, tup);
+		CatalogTupleInsert(pg_type_desc, tup, NULL);
 	}
 
 	/*
@@ -509,9 +490,8 @@ TypeCreate(Oid newTypeOid,
 
 	ObjectAddressSet(address, TypeRelationId, typeObjectId);
 
-	/*
-	 * finish up
-	 */
+	/* Clean up */
+	bms_free(updated);
 	table_close(pg_type_desc, RowExclusiveLock);
 
 	return address;
@@ -765,6 +745,7 @@ RenameTypeInternal(Oid typeOid, const char *newTypeName, Oid typeNamespace)
 	Relation	pg_type_desc;
 	HeapTuple	tuple;
 	Form_pg_type typ;
+	Bitmapset  *updated = NULL;
 	Oid			arrayOid;
 	Oid			oldTypeOid;
 
@@ -804,12 +785,14 @@ RenameTypeInternal(Oid typeOid, const char *newTypeName, Oid typeNamespace)
 	}
 
 	/* OK, do the rename --- tuple is a copy, so OK to scribble on it */
-	namestrcpy(&(typ->typname), newTypeName);
+	namestrcpy(&typ->typname, newTypeName);
+	HeapTupleMarkColumnUpdated(pg_type, typname, updated);
 
-	CatalogTupleUpdate(pg_type_desc, &tuple->t_self, tuple);
+	CatalogTupleUpdate(pg_type_desc, &tuple->t_self, tuple, updated, NULL);
 
 	InvokeObjectPostAlterHook(TypeRelationId, typeOid, 0);
 
+	bms_free(updated);
 	heap_freetuple(tuple);
 	table_close(pg_type_desc, RowExclusiveLock);
 
diff --git a/src/backend/catalog/toasting.c b/src/backend/catalog/toasting.c
index c78dcea98c1..8cdfcdb3d68 100644
--- a/src/backend/catalog/toasting.c
+++ b/src/backend/catalog/toasting.c
@@ -336,14 +336,17 @@ create_toast_table(Relation rel, Oid toastOid, Oid toastIndexOid,
 
 	if (!IsBootstrapProcessingMode())
 	{
+		Bitmapset  *updated = NULL;
+
 		/* normal case, use a transactional update */
 		reltup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(relOid));
 		if (!HeapTupleIsValid(reltup))
 			elog(ERROR, "cache lookup failed for relation %u", relOid);
 
-		((Form_pg_class) GETSTRUCT(reltup))->reltoastrelid = toast_relid;
+		HeapTupleUpdateField(pg_class, reltoastrelid, toast_relid, (Form_pg_class) GETSTRUCT(reltup), updated);
+		CatalogTupleUpdate(class_rel, &reltup->t_self, reltup, updated, NULL);
 
-		CatalogTupleUpdate(class_rel, &reltup->t_self, reltup);
+		bms_free(updated);
 	}
 	else
 	{
diff --git a/src/backend/commands/amcmds.c b/src/backend/commands/amcmds.c
index 21825e8c3f5..efeedc1c3c8 100644
--- a/src/backend/commands/amcmds.c
+++ b/src/backend/commands/amcmds.c
@@ -47,8 +47,8 @@ CreateAccessMethod(CreateAmStmt *stmt)
 	ObjectAddress referenced;
 	Oid			amoid;
 	Oid			amhandler;
-	bool		nulls[Natts_pg_am];
-	Datum		values[Natts_pg_am];
+	Datum		values[Natts_pg_am] = {0};
+	bool		nulls[Natts_pg_am] = {false};
 	HeapTuple	tup;
 
 	rel = table_open(AccessMethodRelationId, RowExclusiveLock);
@@ -84,15 +84,14 @@ CreateAccessMethod(CreateAmStmt *stmt)
 	memset(nulls, false, sizeof(nulls));
 
 	amoid = GetNewOidWithIndex(rel, AmOidIndexId, Anum_pg_am_oid);
-	values[Anum_pg_am_oid - 1] = ObjectIdGetDatum(amoid);
-	values[Anum_pg_am_amname - 1] =
-		DirectFunctionCall1(namein, CStringGetDatum(stmt->amname));
-	values[Anum_pg_am_amhandler - 1] = ObjectIdGetDatum(amhandler);
-	values[Anum_pg_am_amtype - 1] = CharGetDatum(stmt->amtype);
+	HeapTupleSetValue(pg_am, oid, ObjectIdGetDatum(amoid), values);
+	HeapTupleSetValue(pg_am, amname, DirectFunctionCall1(namein, CStringGetDatum(stmt->amname)), values);
+	HeapTupleSetValue(pg_am, amhandler, ObjectIdGetDatum(amhandler), values);
+	HeapTupleSetValue(pg_am, amtype, CharGetDatum(stmt->amtype), values);
 
 	tup = heap_form_tuple(RelationGetDescr(rel), values, nulls);
 
-	CatalogTupleInsert(rel, tup);
+	CatalogTupleInsert(rel, tup, NULL);
 	heap_freetuple(tup);
 
 	myself.classId = AccessMethodRelationId;
diff --git a/src/backend/commands/cluster.c b/src/backend/commands/cluster.c
index 60a4617a585..83b9528fff2 100644
--- a/src/backend/commands/cluster.c
+++ b/src/backend/commands/cluster.c
@@ -557,6 +557,7 @@ mark_index_clustered(Relation rel, Oid indexOid, bool is_internal)
 	Form_pg_index indexForm;
 	Relation	pg_index;
 	ListCell   *index;
+	Bitmapset  *updated = NULL;
 
 	/* Disallow applying to a partitioned table */
 	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
@@ -594,16 +595,16 @@ mark_index_clustered(Relation rel, Oid indexOid, bool is_internal)
 		 */
 		if (indexForm->indisclustered)
 		{
-			indexForm->indisclustered = false;
-			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
+			HeapTupleUpdateField(pg_index, indisclustered, false, indexForm, updated);
+			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple, updated, NULL);
 		}
 		else if (thisIndexOid == indexOid)
 		{
 			/* this was checked earlier, but let's be real sure */
 			if (!indexForm->indisvalid)
 				elog(ERROR, "cannot cluster on invalid index %u", indexOid);
-			indexForm->indisclustered = true;
-			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple);
+			HeapTupleUpdateField(pg_index, indisclustered, true, indexForm, updated);
+			CatalogTupleUpdate(pg_index, &indexTuple->t_self, indexTuple, updated, NULL);
 		}
 
 		InvokeObjectPostAlterHookArg(IndexRelationId, thisIndexOid, 0,
@@ -613,6 +614,7 @@ mark_index_clustered(Relation rel, Oid indexOid, bool is_internal)
 	}
 
 	table_close(pg_index, RowExclusiveLock);
+	bms_free(updated);
 }
 
 /*
@@ -847,6 +849,7 @@ copy_table_data(Relation NewHeap, Relation OldHeap, Relation OldIndex, bool verb
 	int			elevel = verbose ? INFO : DEBUG2;
 	PGRUsage	ru0;
 	char	   *nspname;
+	Bitmapset  *updated = NULL;
 
 	pg_rusage_init(&ru0);
 
@@ -1016,18 +1019,19 @@ copy_table_data(Relation NewHeap, Relation OldHeap, Relation OldIndex, bool verb
 			 RelationGetRelid(NewHeap));
 	relform = (Form_pg_class) GETSTRUCT(reltup);
 
-	relform->relpages = num_pages;
-	relform->reltuples = num_tuples;
+	HeapTupleUpdateField(pg_class, relpages, num_pages, relform, updated);
+	HeapTupleUpdateField(pg_class, reltuples, num_tuples, relform, updated);
 
 	/* Don't update the stats for pg_class.  See swap_relation_files. */
 	if (RelationGetRelid(OldHeap) != RelationRelationId)
-		CatalogTupleUpdate(relRelation, &reltup->t_self, reltup);
+		CatalogTupleUpdate(relRelation, &reltup->t_self, reltup, updated, NULL);
 	else
 		CacheInvalidateRelcacheByTuple(reltup);
 
 	/* Clean up. */
 	heap_freetuple(reltup);
 	table_close(relRelation, RowExclusiveLock);
+	bms_free(updated);
 
 	/* Make the update visible */
 	CommandCounterIncrement();
@@ -1078,6 +1082,8 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 	char		swptmpchr;
 	Oid			relam1,
 				relam2;
+	Bitmapset  *updated1 = NULL;
+	Bitmapset  *updated2 = NULL;
 
 	/* We need writable copies of both pg_class tuples. */
 	relRelation = table_open(RelationRelationId, RowExclusiveLock);
@@ -1107,27 +1113,27 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 		Assert(!target_is_pg_class);
 
 		swaptemp = relform1->relfilenode;
-		relform1->relfilenode = relform2->relfilenode;
-		relform2->relfilenode = swaptemp;
+		HeapTupleUpdateField(pg_class, relfilenode, relform2->relfilenode, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relfilenode, swaptemp, relform2, updated2);
 
 		swaptemp = relform1->reltablespace;
-		relform1->reltablespace = relform2->reltablespace;
-		relform2->reltablespace = swaptemp;
+		HeapTupleUpdateField(pg_class, reltablespace, relform2->reltablespace, relform1, updated1);
+		HeapTupleUpdateField(pg_class, reltablespace, swaptemp, relform2, updated2);
 
 		swaptemp = relform1->relam;
-		relform1->relam = relform2->relam;
-		relform2->relam = swaptemp;
+		HeapTupleUpdateField(pg_class, relam, relform2->relam, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relam, swaptemp, relform2, updated2);
 
 		swptmpchr = relform1->relpersistence;
-		relform1->relpersistence = relform2->relpersistence;
-		relform2->relpersistence = swptmpchr;
+		HeapTupleUpdateField(pg_class, relpersistence, relform2->relpersistence, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relpersistence, swptmpchr, relform2, updated2);
 
 		/* Also swap toast links, if we're swapping by links */
 		if (!swap_toast_by_content)
 		{
 			swaptemp = relform1->reltoastrelid;
-			relform1->reltoastrelid = relform2->reltoastrelid;
-			relform2->reltoastrelid = swaptemp;
+			HeapTupleUpdateField(pg_class, reltoastrelid, relform2->reltoastrelid, relform1, updated1);
+			HeapTupleUpdateField(pg_class, reltoastrelid, swaptemp, relform2, updated2);
 		}
 	}
 	else
@@ -1217,8 +1223,8 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 	{
 		Assert(!TransactionIdIsValid(frozenXid) ||
 			   TransactionIdIsNormal(frozenXid));
-		relform1->relfrozenxid = frozenXid;
-		relform1->relminmxid = cutoffMulti;
+		HeapTupleUpdateField(pg_class, relfrozenxid, frozenXid, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relminmxid, cutoffMulti, relform1, updated1);
 	}
 
 	/* swap size statistics too, since new rel has freshly-updated stats */
@@ -1229,20 +1235,20 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 		int32		swap_allfrozen;
 
 		swap_pages = relform1->relpages;
-		relform1->relpages = relform2->relpages;
-		relform2->relpages = swap_pages;
+		HeapTupleUpdateField(pg_class, relpages, relform2->relpages, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relpages, swap_pages, relform2, updated2);
 
 		swap_tuples = relform1->reltuples;
-		relform1->reltuples = relform2->reltuples;
-		relform2->reltuples = swap_tuples;
+		HeapTupleUpdateField(pg_class, reltuples, relform2->reltuples, relform1, updated1);
+		HeapTupleUpdateField(pg_class, reltuples, swap_tuples, relform2, updated2);
 
 		swap_allvisible = relform1->relallvisible;
-		relform1->relallvisible = relform2->relallvisible;
-		relform2->relallvisible = swap_allvisible;
+		HeapTupleUpdateField(pg_class, relallvisible, relform2->relallvisible, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relallvisible, swap_allvisible, relform2, updated2);
 
 		swap_allfrozen = relform1->relallfrozen;
-		relform1->relallfrozen = relform2->relallfrozen;
-		relform2->relallfrozen = swap_allfrozen;
+		HeapTupleUpdateField(pg_class, relallfrozen, relform2->relallfrozen, relform1, updated1);
+		HeapTupleUpdateField(pg_class, relallfrozen, swap_allfrozen, relform2, updated2);
 	}
 
 	/*
@@ -1256,13 +1262,11 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 	 */
 	if (!target_is_pg_class)
 	{
-		CatalogIndexState indstate;
+		CatalogIndexState indstate = CatalogOpenIndexes(relRelation);
+
+		CatalogTupleUpdate(relRelation, &reltup1->t_self, reltup1, updated1, indstate);
+		CatalogTupleUpdate(relRelation, &reltup2->t_self, reltup2, updated2, indstate);
 
-		indstate = CatalogOpenIndexes(relRelation);
-		CatalogTupleUpdateWithInfo(relRelation, &reltup1->t_self, reltup1,
-								   indstate);
-		CatalogTupleUpdateWithInfo(relRelation, &reltup2->t_self, reltup2,
-								   indstate);
 		CatalogCloseIndexes(indstate);
 	}
 	else
@@ -1435,6 +1439,8 @@ swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
 	heap_freetuple(reltup2);
 
 	table_close(relRelation, RowExclusiveLock);
+	bms_free(updated1);
+	bms_free(updated2);
 }
 
 /*
@@ -1535,6 +1541,7 @@ finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
 		Relation	relRelation;
 		HeapTuple	reltup;
 		Form_pg_class relform;
+		Bitmapset  *updated = NULL;
 
 		relRelation = table_open(RelationRelationId, RowExclusiveLock);
 
@@ -1543,12 +1550,13 @@ finish_heap_swap(Oid OIDOldHeap, Oid OIDNewHeap,
 			elog(ERROR, "cache lookup failed for relation %u", OIDOldHeap);
 		relform = (Form_pg_class) GETSTRUCT(reltup);
 
-		relform->relfrozenxid = frozenXid;
-		relform->relminmxid = cutoffMulti;
+		HeapTupleUpdateField(pg_class, relfrozenxid, frozenXid, relform, updated);
+		HeapTupleUpdateField(pg_class, relminmxid, cutoffMulti, relform, updated);
 
-		CatalogTupleUpdate(relRelation, &reltup->t_self, reltup);
+		CatalogTupleUpdate(relRelation, &reltup->t_self, reltup, updated, NULL);
 
 		table_close(relRelation, RowExclusiveLock);
+		bms_free(updated);
 	}
 
 	/* Destroy new heap with old filenumber */
diff --git a/src/backend/commands/collationcmds.c b/src/backend/commands/collationcmds.c
index 0bc31ec2b6f..0fe19f2ef87 100644
--- a/src/backend/commands/collationcmds.c
+++ b/src/backend/commands/collationcmds.c
@@ -432,6 +432,7 @@ AlterCollation(AlterCollationStmt *stmt)
 	Oid			collOid;
 	HeapTuple	tup;
 	Form_pg_collation collForm;
+	Bitmapset  *updated = NULL;
 	Datum		datum;
 	bool		isnull;
 	char	   *oldversion;
@@ -464,6 +465,7 @@ AlterCollation(AlterCollationStmt *stmt)
 		datum = SysCacheGetAttrNotNull(COLLOID, tup, Anum_pg_collation_collcollate);
 	else
 		datum = SysCacheGetAttrNotNull(COLLOID, tup, Anum_pg_collation_colllocale);
+	HeapTupleMarkColumnUpdated(pg_collation, collcollate, updated);
 
 	newversion = get_collation_actual_version(collForm->collprovider,
 											  TextDatumGetCString(datum));
@@ -473,29 +475,22 @@ AlterCollation(AlterCollationStmt *stmt)
 		elog(ERROR, "invalid collation version change");
 	else if (oldversion && newversion && strcmp(newversion, oldversion) != 0)
 	{
-		bool		nulls[Natts_pg_collation];
-		bool		replaces[Natts_pg_collation];
-		Datum		values[Natts_pg_collation];
+		bool		nulls[Natts_pg_collation] = {false};
+		Datum		values[Natts_pg_collation] = {0};
 
 		ereport(NOTICE,
 				(errmsg("changing version from %s to %s",
 						oldversion, newversion)));
 
-		memset(values, 0, sizeof(values));
-		memset(nulls, false, sizeof(nulls));
-		memset(replaces, false, sizeof(replaces));
+		HeapTupleUpdateValue(pg_collation, collversion, CStringGetTextDatum(newversion), values, nulls, updated);
 
-		values[Anum_pg_collation_collversion - 1] = CStringGetTextDatum(newversion);
-		replaces[Anum_pg_collation_collversion - 1] = true;
-
-		tup = heap_modify_tuple(tup, RelationGetDescr(rel),
-								values, nulls, replaces);
+		tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
 	}
 	else
 		ereport(NOTICE,
 				(errmsg("version has not changed")));
 
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
 	InvokeObjectPostAlterHook(CollationRelationId, collOid, 0);
 
@@ -503,6 +498,7 @@ AlterCollation(AlterCollationStmt *stmt)
 
 	heap_freetuple(tup);
 	table_close(rel, NoLock);
+	bms_free(updated);
 
 	return address;
 }
